// RSSFU DVBT Coder ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSFU DVBT Coder Example.h"
#include "RSSFU DVBT Coder ExampleDlg.h"
#include "resource.h"
#include <rssfu.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define CHECKERR(fcal) if ((rssfu_status = fcal) < 0){\
								 rssfu_close(io);\
        						 sprintf (buffer, "Error: %ld, %s", rssfu_status, #fcal);\
        						 GetDlgItem(ID_APPLY)->EnableWindow (TRUE);\
								 AfxMessageBox (buffer, MB_OK);\
        						 return;\
        						 }

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSFUDVBTCoderExampleDlg dialog

CRSSFUDVBTCoderExampleDlg::CRSSFUDVBTCoderExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSFUDVBTCoderExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSFUDVBTCoderExampleDlg)
	m_ResName = _T("GPIB::28");
	m_CodeRateHP = 2;
	m_CodeRateLP = 2;
	m_Constellation = 0;
	m_DVBH = FALSE;
	m_FFTMode = 2;
	m_Frequency = 1.0e9;
	m_Query = TRUE;
	m_InputSelectHP = 0;
	m_InputSelectLP = 2;
	m_Level = -99.0;
	m_ModeHP = 0;
	m_ModeLP = 0;
	m_Modulation = TRUE;
	m_Reset = TRUE;
	m_SourceHP = 1;
	m_SourceLP = 1;
	m_StuffingHP = 1;
	m_StuffingLP = 1;
	m_RF = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRSSFUDVBTCoderExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSFUDVBTCoderExampleDlg)
	DDX_Text(pDX, IDC_RESOURCE_DESCRIPTOR, m_ResName);
	DDX_CBIndex(pDX, IDC_CODE_RATE_HP, m_CodeRateHP);
	DDX_CBIndex(pDX, IDC_CODE_RATE_LP, m_CodeRateLP);
	DDX_CBIndex(pDX, IDC_CONSTELLATION, m_Constellation);
	DDX_Check(pDX, IDC_DVBH, m_DVBH);
	DDX_CBIndex(pDX, IDC_FFT_MODE, m_FFTMode);
	DDX_Text(pDX, IDC_FREQ, m_Frequency);
	DDX_Check(pDX, IDC_ID_QUERY, m_Query);
	DDX_CBIndex(pDX, IDC_INPUT_SELECT_HP, m_InputSelectHP);
	DDX_CBIndex(pDX, IDC_INPUT_SELECT_LP, m_InputSelectLP);
	DDX_Text(pDX, IDC_LEVEL, m_Level);
	DDX_CBIndex(pDX, IDC_MODE_HP, m_ModeHP);
	DDX_CBIndex(pDX, IDC_MODE_LP, m_ModeLP);
	DDX_Check(pDX, IDC_MODULATION, m_Modulation);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_CBIndex(pDX, IDC_SOURCE_HP, m_SourceHP);
	DDX_CBIndex(pDX, IDC_SOURCE_LP, m_SourceLP);
	DDX_CBIndex(pDX, IDC_STUFFING_HP, m_StuffingHP);
	DDX_CBIndex(pDX, IDC_STUFFING_LP, m_StuffingLP);
	DDX_Check(pDX, IDC_RF, m_RF);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSSFUDVBTCoderExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CRSSFUDVBTCoderExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_APPLY, OnApply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSFUDVBTCoderExampleDlg message handlers

BOOL CRSSFUDVBTCoderExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRSSFUDVBTCoderExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSSFUDVBTCoderExampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSSFUDVBTCoderExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRSSFUDVBTCoderExampleDlg::OnApply()
{
	ViStatus	rssfu_status;
	ViSession	io;
	ViInt32		sync = 0;
	char		buffer[512];
	ViInt32		hierarchyVal, constelVal;
	
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	GetDlgItem(ID_APPLY)->EnableWindow (FALSE);
	
	UpdateData();

    /* Initialize the driver */
	rssfu_status = rssfu_init((char *) ((LPCTSTR) m_ResName), (int)(m_Query), (int)(m_Reset), &io);
	if (rssfu_status < 0)
	{
		AfxMessageBox ("Could not open the session!", MB_OK);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );
		return;
	}

             
            
             
	CHECKERR (rssfu_confTxFreq (io, m_Frequency, 0.0));
	CHECKERR (rssfu_confTxLevel (io, m_Level, m_RF, 0.0, 20.0,
							 RSSFU_RFOUT_AMODE_AUTO, RSSFU_VAL_POW_LEV_DBM));
	CHECKERR (rssfu_confDVBTInputSignal (io, RSSFU_VAL_PRIORITY_HIGH, m_SourceHP,
		    						m_InputSelectLP, m_StuffingHP));

	switch (m_Constellation){
	case  0:
	case  1: 
	case  2: 
			hierarchyVal = 0; 
			constelVal = m_Constellation;
	break;

	case  3:
	case  4: 
	case  5: 
			hierarchyVal = m_Constellation - 2; 
			constelVal = 1;
	break;

	case  6:
	case  7: 
	case  8: 
			hierarchyVal = m_Constellation - 5; 
			constelVal = 2;
	break;
	}    

	CHECKERR (rssfu_confDVBTCoding (io, RSSFU_IQC_DVBT_CHBW6, 5.0e6,
								m_FFTMode, RSSFU_IQC_DVBT_GUAR_14,
								hierarchyVal, constelVal));

	CHECKERR (rssfu_confDVBTCodeRate (io, RSSFU_VAL_PRIORITY_HIGH, m_CodeRateLP));
	CHECKERR (rssfu_confDVBTTestSignal (io, RSSFU_VAL_PRIORITY_HIGH, m_ModeLP));

	if (m_Constellation > 2) 
	{
		CHECKERR (rssfu_confDVBTInputSignal (io, RSSFU_VAL_PRIORITY_LOW, m_SourceLP,
		    							m_InputSelectHP, m_StuffingLP));
		CHECKERR (rssfu_confDVBTCodeRate (io, RSSFU_VAL_PRIORITY_LOW, m_CodeRateHP));
		CHECKERR (rssfu_confDVBTTestSignal (io, RSSFU_VAL_PRIORITY_LOW, m_ModeHP));
	}

	CHECKERR (rssfu_confTxModulation (io, m_Modulation, RSSFU_VAL_DM_SOURCE_DTV,
								  RSSFU_VAL_DM_STANDARD_DVBT, RSSFU_VAL_DM_SPEC_POLAR_NORM));
	CHECKERR (rssfu_confDVBHCoding (io, m_DVBH, RSSFU_IQC_DVBT_SYMB_NAT));

	rssfu_close(io);
             

	GetDlgItem(ID_APPLY)->EnableWindow (TRUE);
}
